def collect(root, active_path):
    active = []
    idle = []
    hidden = []
    active_len = len(active_path)

    locs = filter((lambda org: org.meta_type == 'Location'),
            root.getSubOrganizers())    # filter out other organizers
    for loc in locs:
        if not (loc.hasProperty('latitude') and loc.hasProperty('longitude')):
            hidden.append(loc)  # not geolocated location
        elif loc.getPhysicalPath()[:active_len] == active_path:
            active.append(loc)  # geolocated and under active_path
        else:
            idle.append(loc)    # geolocated but outside active_path

    return (active, idle, hidden)

current = None
root_loc = context.getOrganizer('/')
active, idle, hidden = collect(root_loc, context.getPhysicalPath())
if context.meta_type == 'Location':
    current = context
return (current, active, idle, hidden)
